; dzaxxon.asm
; dumps C64 cartridge: Zaxxon
; Version 1.2
; machine language part


* = $0801

.INCLUDE SYSTEM.ASM			; KERNAL functions

		.byte $26,$08,$0a,$00,$99,$22
		.text "DZAXXON - ZAXXON DUMPER V 1.2"
		.byte $22,$00
		.byte $40,$08,$14,$00,$85,$22,$11
		.text "ENTER FILENAME"
		.byte $22,$3b,$4e,$24,$00
		.byte $4a,$08,$1e,$00,$9e,$32,$31,$32,$35,$00
		.byte $00,$00,$00
		
		JSR  _copyfilename
		JSR  _promptSwitch
		SEI
		JSR  _waitFire
		JSR  _busywait
		CLI
		JSR  _promptSave
		JSR  _waitFire
		JSR  _copyZaxxon
		JSR  _saveCart
		JSR  _promptDone
_the_end	JMP  _the_end
	


_copyfilename	LDY  #$02
		LDA  ($2d),Y
		STA  _namelen
		INY
		LDA  ($2d),Y
		STA  $fb
		INY
		LDA  ($2d),Y
		STA  $fc

		LDA  _namelen
		TAX
		LDY  #$00
_copyname	LDA  ($fb),Y
		STA  _filename,Y
		INY
		DEX
		BNE  _copyname

		RTS


_findRTS	LDY  #$00		; find 'RTS' opcode in $8000-$8fff
_FRTSL1		LDA  $8000,Y
		CMP  #$60
		BEQ  _FRTSJ1
		INY
		BNE  _FRTSL1
		INC  _FRTSL1+2
		BNE  _FRTSL1
_FRTSJ1		TYA
		STA  _CZL2+1
		LDA  _FRTSL1+2
		STA  _CZL2+2

		LDY  #$00		; find 'RTS' opcode in $9000-$9fff
_FRTSL2		LDA  $9000,Y
		CMP  #$60
		BEQ  _FRTSJ2
		INY
		BNE  _FRTSL2
		INC  _FRTSL2+2
		BNE  _FRTSL2
_FRTSJ2		TYA
		STA  _CZL3+1
		LDA  _FRTSL2+2
		STA  _CZL3+2

		RTS


_copyLoop	LDA  ($fb),Y
		STA  ($fd),Y
		INY
		BNE  _copyLoop
		INC  $fc
		INC  $fe
		DEX
		BNE  _copyLoop
		RTS


_copyZaxxon	JSR  _findRTS
		LDA  #$00
		STA  $fb
		STA  $fd
		LDA  #$80		; source = $8000
		STA  $fc
		LDA  #$10		; destination $fc/$fd = $1000
		STA  $fe
		LDX  #$20		; copy $20 pages
		LDY  #$00
		JSR  _copyLoop

_CZL2		JSR  $8000		; substituted by JSR -> RTS ($8000)
		LDA  #$a0		; source: $a000
		STA  $fc
		LDX  #$20
		JSR  _copyLoop

_CZL3		JSR  $8000		; substituted by JSR -> RTS ($8000)
		LDA  #$a0		; source: $a000
		STA  $fc
		LDX  #$20
		JSR  _copyLoop


		RTS



_saveCart	JSR  CLRCHN
		JSR  CLALL
		LDA  #$01
		LDX  $ba		; FA - Use current Device Number
		TAY
		JSR  SETLFS		; SETLFS 1,8,1

		LDA  _namelen
		LDX  #<_filename
		LDY  #>_filename
		JSR  SETNAM
		LDX  #$00		; source memory $1000
		LDY  #$10		;  $1000:  8kB ROM (or 2 x 4kB)
		STX  $fb		;  $3000: 16kB ROM
		STY  $fc
		LDA  #$fb
		LDX  #$00		; end of source memory $7000
		LDY  #$70
		JSR  SAVE
		LDA  #$01
		JSR  CLOSE
		RTS

_namelen	.byte $00
_filename	.text "FILENAME GOES HERE"


_promptSwitch	JSR  $e544		; CLR
		JSR  $e566		; HOME
		LDY  #$00
_promptSwitchL1	LDA  _switch_text,Y
		BEQ  _promptSwitchJ1
		JSR  CHROUT
		INY
		BNE  _promptSwitchL1
_promptSwitchJ1	RTS


_promptSave	LDY  #$00
_promptSaveL1	LDA  _save_text,Y
		BEQ  _promptSaveJ1
		JSR  CHROUT
		INY
		BNE  _promptSaveL1
_promptSaveJ1	RTS

_promptDone	LDY  #$00
_promptDoneL1	LDA  _done_text,Y
		BEQ  _promptDoneJ1
		JSR  CHROUT
		INY
		BNE  _promptDoneL1
_promptDoneJ1	RTS


_busywait	LDA  #$10
		LDX  #$00
		LDY  #$00
_busywaitL1	DEY
		BNE  _busywaitL1
		DEX
		BNE  _busywaitL1
		CLC
		SBC  #$01
		STA  $d020
		BNE  _busywaitL1
		RTS

_switch_text	.text "PRESS <SPACE> KEY, THEN THROW SWITCH!"
		.byte 0

_save_text	.byte $0d,$0d
		.text "PLEASE INSERT SAVE DISK"
		.byte $0d
		.text "AND PRESS <SPACE> KEY!"
		.byte 0

_done_text	.byte $0d,$0d
		.text "DONE!"
		.byte 0


_waitFire	LDA  $dc00		; wait for fire button up
		AND  $dc01
		AND  #$10
		BEQ  _waitFire
_waitFireL1	LDA  $dc00		; wait for fire button
		AND  $dc01
		AND  #$10
		BNE  _waitFireL1
		RTS

_end		.byte $00,$00,$00
